from typing import Optional

from bot_api.abc.dto_abc import DtoABC
from bot_api.model.auth_user_dto import AuthUserDTO
from bot_data.model.auth_role_enum import AuthRoleEnum


class OAuthDTO(DtoABC):
    def __init__(
        self,
        user: AuthUserDTO,
        o_auth_id: Optional[str],
    ):
        DtoABC.__init__(self)

        self._user = user
        self._oauth_id = o_auth_id

    @property
    def user(self) -> AuthUserDTO:
        return self._user

    @user.setter
    def user(self, value: AuthUserDTO):
        self._user = value

    @property
    def oauth_id(self) -> Optional[str]:
        return self._oauth_id

    @oauth_id.setter
    def oauth_id(self, value: Optional[str]):
        self._oauth_id = value

    def from_dict(self, values: dict):
        self._user = AuthUserDTO().from_dict(values["user"])
        self._oauth_id = values["oAuthId"]

    def to_dict(self) -> dict:
        return {"user": self._user.to_dict(), "oAuthId": self._oauth_id}
