from typing import Optional

import discord

from bot_api.abc.transformer_abc import TransformerABC
from bot_api.model.discord.server_dto import ServerDTO
from bot_data.model.server import Server


class ServerTransformer(TransformerABC):
    @staticmethod
    def to_db(dto: ServerDTO) -> Server:
        return Server(dto.discord_id)

    @staticmethod
    def to_dto(db: Server, name: str, member_count: int, icon_url: Optional[discord.Asset]) -> ServerDTO:
        return ServerDTO(
            db.server_id,
            db.discord_server_id,
            name,
            member_count,
            icon_url.url if icon_url is not None else None,
        )
