from cpl_query.extension import List

from bot_graphql.abc.filter_abc import FilterABC


class Page(FilterABC):
    def __init__(self):
        FilterABC.__init__(self)
        self._page_index = None
        self._page_size = None

    def from_dict(self, values: dict):
        if "page_index" in values:
            self._page_index = int(values["page_index"])

        if "page_size" in values:
            self._page_size = int(values["page_size"])

    def filter(self, query: List, *args) -> List:
        if self._page_size is not None and self._page_index is not None:
            skip = self._page_size * self._page_index
            result = query.skip(skip).take(self._page_size)
            return result

        return query
