from bot_data.abc.auto_role_repository_abc import AutoRoleRepositoryABC
from bot_data.model.auto_role_rule import AutoRoleRule
from bot_graphql.abc.data_query_abc import DataQueryABC


class AutoRoleRuleQuery(DataQueryABC):
    def __init__(
        self,
        auto_roles: AutoRoleRepositoryABC,
    ):
        DataQueryABC.__init__(self, "AutoRoleRule")

        self._auto_roles = auto_roles

        self.set_field("id", self.resolve_id)
        self.set_field("emoji_name", self.resolve_emoji_name)
        self.set_field("role_id", self.resolve_role_id)
        self.set_field("auto_role", self.resolve_auto_role)

    @staticmethod
    def resolve_id(x: AutoRoleRule, *_):
        return x.auto_role_rule_id

    @staticmethod
    def resolve_emoji_name(x: AutoRoleRule, *_):
        return x.emoji_name

    @staticmethod
    def resolve_role_id(x: AutoRoleRule, *_):
        return x.role_id

    def resolve_auto_role(self, x: AutoRoleRule, *_):
        return self._auto_roles.get_auto_role_by_id(x.auto_role_id)
